package ejb31.war.servlet;

import javax.naming.InitialContext;
import javax.annotation.PostConstruct;
import javax.ejb.Singleton;
import javax.persistence.*;
import javax.transaction.*;


@PersistenceContext(name="myem", unitName="pu1")
@Singleton
public class AnnotatedEJB {

    // workaround for 5828
    // @PersistenceContext
    private EntityManager em;
    private String name = "foo";


    @PostConstruct
    public void afterConstruct() {
        System.out.println("------------------------------------");
        System.out.println("---PostConstruct in AnnotatedEJB----");
        System.out.println("------------------------------------");
        lookupEm();

    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getEm() {
        return name;
    }

    public void setEm(EntityManager em) {
        this.em = em;
    }

    public void lookupEm() {
        try {
	  InitialContext ic = new InitialContext();
	  EntityManager em = (EntityManager) ic.lookup("java:comp/env/myem");
	  setEm(em);
        }catch (Exception ex) {
            System.out.println("failed to lookup em");
            ex.printStackTrace();
        }

    }

    public boolean persistEntity(){
        boolean pass = false;
        try {
	  JpaBean jpaBean = new JpaBean();
	  jpaBean.setName("JpaBean");
          System.out.println("Persisting ....");
	  em.persist(jpaBean);
          pass = true;
	} catch (Throwable e) {
           e.printStackTrace();
	}
        return pass;
    }

    public boolean removeEntity(){
        boolean pass = false;

        try {
	  Query query = em.createQuery("SELECT j FROM JpaBean j WHERE j.name='JpaBean'");
	  JpaBean jpaBean = (JpaBean) query.getSingleResult();
	  System.out.println("Loaded " + jpaBean);
	  em.remove(jpaBean);
          pass = true;
	} catch (Throwable e) {
           e.printStackTrace();
	}
        return pass;
    }

    public boolean verifyRemove(){
        boolean pass = false;

        try {
	  Query query = em.createQuery("SELECT count(j) FROM JpaBean j WHERE j.name='JpaBean'");
	  int count = ((Number) query.getSingleResult()).intValue();
	  if (count == 0) {
            pass = true;
	  }
	} catch (Throwable e) {
           e.printStackTrace();
	} 
        return pass;
    }

    public String toString() {
        return "AnnotatedEJB[name=" + name + "]";
    }
}
